Index: trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 635)
@@ -156,200 +166,698 @@
       limdown=1e-20
       limup=1e26
-         do i=1,nz
-            aux2(nz-i+1) = o2colx(i) + o3pcolx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,3,nz2-i+1)
-            aux4(i) = c23(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup)
-         do i=1,nz
-            jfotsout(indexint,3,i) = aux1(nz-i+1)
-         enddo
-
-
-c************************************************
-c     h2,0.1,5.0
-c************************************************
+      do i=1,nlayermx
+         aux1(i)=0.
+         aux2(nlayermx-i+1) =  co2colx(i)*crscabsi2(1,indexint) +
+     $        o2colx(i)*crscabsi2(2,indexint) + 
+     $        o3pcolx(i)*crscabsi2(3,indexint) + 
+     $        h2colx(i)*crscabsi2(5,indexint) + 
+     $        ncolx(i)*crscabsi2(9,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
+      enddo
+
+c**************************************************         
+c     o3p,0.1,6.0
+c**************************************************
 
       indexint=1
       limdown=1e-20
       limup=1e26
-         do i=1,nz
-            aux2(nz-i+1) = o2colx(i) + o3pcolx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,5,nz2-i+1)
-            aux4(i) = c23(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-            jfotsout(indexint,5,i) = aux1(nz-i+1)
-         enddo
-
-
-c************************************************
-c     interpola para el o2 entre 5 y 90.8nm
-c************************************************
-
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) =  co2colx(i)*crscabsi2(1,indexint) +
+     $        o2colx(i)*crscabsi2(2,indexint) + 
+     $        o3pcolx(i)*crscabsi2(3,indexint) + 
+     $        h2colx(i)*crscabsi2(5,indexint) + 
+     $        ncolx(i)*crscabsi2(9,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,3,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,3,i) = aux1(nlayermx-i+1)
+      enddo
+
+      
+c**************************************************
+c     h2,0.1,6.0
+c**************************************************
+
+      indexint=1
       limdown=1e-20
-      limup=1e12
-      do indexint=2,16
-         co2colx2(nz,indexint)= co2colx(nz) 
-     $              * crscabsi2(1,indexint)
-         o2colx2(nz,indexint)= o2colx(nz) 
-     $              * crscabsi2(2,indexint)
-         o3pcolx2(nz,indexint)= o3pcolx(nz) 
-     $              * crscabsi2(3,indexint)
-         do i=nz-1,1,-1
-            co2colx2(i,indexint) = co2colx2(i+1,indexint) + 
-     $         ( xabsi(1,i) + xabsi(1,i+1) ) * 0.5 
-     $           * 1e5 * (iz(i+1)-iz(i)) * crscabsi2(1,indexint)
-            o2colx2(i,indexint) = o2colx2(i+1,indexint) + 
-     $         ( xabsi(2,i) + xabsi(2,i+1) ) * 0.5 
-     $         * 1e5 * (iz(i+1)-iz(i)) * crscabsi2(2,indexint)
-            o3pcolx2(i,indexint) = o3pcolx2(i+1,indexint) + 
-     $         ( xabsi(3,i) + xabsi(3,i+1) ) * 0.5 
-     $         * 1e5 * (iz(i+1)-iz(i)) * crscabsi2(3,indexint)
-         end do
-         do i=1,nz
-            aux2(nz-i+1) = co2colx2(i,indexint)+
-     $      o2colx2(i,indexint)+
-     $      o3pcolx2(i,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,2,nz2-i+1)
-            aux4(i) = c123(indexint,nz2-i+1)
+      limup=1e26
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) =  co2colx(i)*crscabsi2(1,indexint) +
+     $        o2colx(i)*crscabsi2(2,indexint) + 
+     $        o3pcolx(i)*crscabsi2(3,indexint) + 
+     $        h2colx(i)*crscabsi2(5,indexint) + 
+     $        ncolx(i)*crscabsi2(9,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,5,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,5,i) = aux1(nlayermx-i+1)
+      enddo
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+
+c**************************************************
+c     n,0.1,6.0
+c**************************************************
+
+
+         indexint=1
+         limdown=1e-20
+         limup=1e26
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) =  co2colx(i)*crscabsi2(1,indexint) +
+     $           o2colx(i)*crscabsi2(2,indexint) + 
+     $           o3pcolx(i)*crscabsi2(3,indexint) + 
+     $           h2colx(i)*crscabsi2(5,indexint) + 
+     $           ncolx(i)*crscabsi2(9,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,9,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,9,i) = aux1(nlayermx-i+1)
+         enddo
+
+      endif  !Of chemthermod >= 2
+      
+
+c**************************************************
+c     o2, 5-80.5nm
+c**************************************************
+
+      limdown=1e-20
+      limup=1e26
+      do indexint=2,15
+         do i=nlayermx-1,1,-1
+         end do
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           h2colx(i)*crscabsi2(5,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
          enddo
           call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-          do i=1,nz
-            jfotsout(indexint,2,i) = aux1(nz-i+1) 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+          do i=1,nlayermx
+            jfotsout(indexint,2,i) = aux1(nlayermx-i+1) 
           enddo
       end do
       
 
-c************************************************
-c     idem para o3p entre 5 y 90.8nm
-c************************************************
-
-      do indexint=2,16
-         do i=1,nz
-            aux2(nz-i+1) = co2colx2(i,indexint) +
-     $      o2colx2(i,indexint) +
-     $      o3pcolx2(i,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,3,nz2-i+1)
-            aux4(i) = c123(indexint,nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-            jfotsout(indexint,3,i) = aux1(nz-i+1)
-         enddo
-      end do
-
-
-c************************************************
-c     idem para co2 entre 5 y 90.8nm
-c************************************************
-
-      do indexint=2,16
-         do i=1,nz
-            aux2(nz-i+1) = co2colx2(i,indexint) +
-     $      o2colx2(i,indexint) +
-     $      o3pcolx2(i,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,1,nz2-i+1)
-            aux4(i) = c123(indexint,nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-            jfotsout(indexint,1,i) = aux1(nz-i+1)
-         enddo
-      end do
-
-
-c************************************************
-c     idem para h2 entre 5 y 80.6nm
-c************************************************
+c**************************************************
+c     o3p, 5-80.5nm
+c**************************************************
 
       do indexint=2,15
-         do i=1,nz
-            aux2(nz-i+1) = co2colx2(i,indexint) +
-     $      o2colx2(i,indexint) +
-     $      o3pcolx2(i,indexint)
-         end do
-         do i=1,nabs
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,5,nz2-i+1)
-            aux4(i) = c123(indexint,nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-            jfotsout(indexint,5,i) = aux1(nz-i+1)
-         enddo
-      end do
-
-
-c************************************************
-c      co2,90.9,119.5
-c************************************************
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           h2colx(i)*crscabsi2(5,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,3,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,3,i) = aux1(nlayermx-i+1)
+         enddo
+      end do
+
+c**************************************************
+c     co2, 5-80.5nm
+c**************************************************
+
+      do indexint=2,15
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           h2colx(i)*crscabsi2(5,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
+         enddo
+      end do
+
+
+c**************************************************
+c     h2, 5-80.5nm
+c**************************************************
+
+      do indexint=2,15
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           h2colx(i)*crscabsi2(5,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,5,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,5,i) = aux1(nlayermx-i+1)
+         enddo
+      end do
+
+
+c**************************************************
+c     n2, 5-80.5nm
+c**************************************************
+
+      do indexint=2,15
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           h2colx(i)*crscabsi2(5,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,8,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,8,i) = aux1(nlayermx-i+1)
+         enddo
+      end do
+
+
+c**************************************************
+c     co, 5-80.5nm
+c**************************************************
+
+      do indexint=2,15
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           h2colx(i)*crscabsi2(5,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,11,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,11,i) = aux1(nlayermx-i+1)
+         enddo
+      end do
+
+
+c**************************************************
+c     h, 5-80.5nm
+c**************************************************
+
+      do indexint=2,15
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           h2colx(i)*crscabsi2(5,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,12,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,12,i) = aux1(nlayermx-i+1)
+         enddo
+      end do
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+c**************************************************
+c     n, 5-80.5nm
+c**************************************************
+
+         do indexint=2,15
+            do i=1,nlayermx
+               aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $              o2colx(i)*crscabsi2(2,indexint)+
+     $              o3pcolx(i)*crscabsi2(3,indexint)+
+     $              h2colx(i)*crscabsi2(5,indexint)+
+     $              n2colx(i)*crscabsi2(8,indexint)+
+     $              ncolx(i)*crscabsi2(9,indexint)+
+     $              nocolx(i)*crscabsi2(10,indexint)+
+     $              cocolx(i)*crscabsi2(11,indexint)+
+     $              hcolx(i)*crscabsi2(12,indexint)+
+     $              no2colx(i)*crscabsi2(13,indexint)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,9,nz2-i+1)
+               aux4(i) = c1_16(nz2-i+1,indexint)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               jfotsout(indexint,9,i) = aux1(nlayermx-i+1)
+            enddo
+         end do
+
+
+c**************************************************
+c     no, 5-80.5nm
+c**************************************************
+
+         do indexint=2,15
+            do i=1,nlayermx
+               aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $              o2colx(i)*crscabsi2(2,indexint)+
+     $              o3pcolx(i)*crscabsi2(3,indexint)+
+     $              h2colx(i)*crscabsi2(5,indexint)+
+     $              n2colx(i)*crscabsi2(8,indexint)+
+     $              ncolx(i)*crscabsi2(9,indexint)+
+     $              nocolx(i)*crscabsi2(10,indexint)+
+     $              cocolx(i)*crscabsi2(11,indexint)+
+     $              hcolx(i)*crscabsi2(12,indexint)+
+     $              no2colx(i)*crscabsi2(13,indexint)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
+               aux4(i) = c1_16(nz2-i+1,indexint)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
+            enddo
+         end do
+
+c**************************************************
+c     no2, 5-80.5nm
+c**************************************************
+
+         do indexint=2,15
+            do i=1,nlayermx
+               aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $              o2colx(i)*crscabsi2(2,indexint)+
+     $              o3pcolx(i)*crscabsi2(3,indexint)+
+     $              h2colx(i)*crscabsi2(5,indexint)+
+     $              n2colx(i)*crscabsi2(8,indexint)+
+     $              ncolx(i)*crscabsi2(9,indexint)+
+     $              nocolx(i)*crscabsi2(10,indexint)+
+     $              cocolx(i)*crscabsi2(11,indexint)+
+     $              hcolx(i)*crscabsi2(12,indexint)+
+     $              no2colx(i)*crscabsi2(13,indexint)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+               aux4(i) = c1_16(nz2-i+1,indexint)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+            enddo
+         end do
+      
+         endif  !Of chemthermod >= 2
+
+         
+c**************************************************
+c     o2, 80.6-90.8nm
+c**************************************************
+
+      indexint=16
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $        o2colx(i)*crscabsi2(2,indexint)+
+     $        o3pcolx(i)*crscabsi2(3,indexint)+
+     $        n2colx(i)*crscabsi2(8,indexint)+
+     $        ncolx(i)*crscabsi2(9,indexint)+
+     $        nocolx(i)*crscabsi2(10,indexint)+
+     $        cocolx(i)*crscabsi2(11,indexint)+
+     $        hcolx(i)*crscabsi2(12,indexint)+
+     $        no2colx(i)*crscabsi2(13,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,2,i) = aux1(nlayermx-i+1) 
+      enddo
+
+
+c**************************************************
+c     co2, 80.6-90.8nm
+c**************************************************
+
+      indexint=16
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $        o2colx(i)*crscabsi2(2,indexint)+
+     $        o3pcolx(i)*crscabsi2(3,indexint)+
+     $        n2colx(i)*crscabsi2(8,indexint)+
+     $        ncolx(i)*crscabsi2(9,indexint)+
+     $        nocolx(i)*crscabsi2(10,indexint)+
+     $        cocolx(i)*crscabsi2(11,indexint)+
+     $        hcolx(i)*crscabsi2(12,indexint)+
+     $        no2colx(i)*crscabsi2(13,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,1,i) = aux1(nlayermx-i+1) 
+      enddo
+
+
+c**************************************************
+c     o3p, 80.6-90.8nm
+c**************************************************
+
+      indexint=16
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $        o2colx(i)*crscabsi2(2,indexint)+
+     $        o3pcolx(i)*crscabsi2(3,indexint)+
+     $        n2colx(i)*crscabsi2(8,indexint)+
+     $        ncolx(i)*crscabsi2(9,indexint)+
+     $        nocolx(i)*crscabsi2(10,indexint)+
+     $        cocolx(i)*crscabsi2(11,indexint)+
+     $        hcolx(i)*crscabsi2(12,indexint)+
+     $        no2colx(i)*crscabsi2(13,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,3,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,3,i) = aux1(nlayermx-i+1) 
+      enddo
+      
+
+c**************************************************
+c     n2, 80.6-90.8nm
+c**************************************************
+
+      indexint=16
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $        o2colx(i)*crscabsi2(2,indexint)+
+     $        o3pcolx(i)*crscabsi2(3,indexint)+
+     $        n2colx(i)*crscabsi2(8,indexint)+
+     $        ncolx(i)*crscabsi2(9,indexint)+
+     $        nocolx(i)*crscabsi2(10,indexint)+
+     $        cocolx(i)*crscabsi2(11,indexint)+
+     $        hcolx(i)*crscabsi2(12,indexint)+
+     $        no2colx(i)*crscabsi2(13,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,8,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,8,i) = aux1(nlayermx-i+1) 
+      enddo
+
+
+c**************************************************
+c     co, 80.6-90.8nm
+c************************************************************
+
+      indexint=16
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $        o2colx(i)*crscabsi2(2,indexint)+
+     $        o3pcolx(i)*crscabsi2(3,indexint)+
+     $        n2colx(i)*crscabsi2(8,indexint)+
+     $        ncolx(i)*crscabsi2(9,indexint)+
+     $        nocolx(i)*crscabsi2(10,indexint)+
+     $        cocolx(i)*crscabsi2(11,indexint)+
+     $        hcolx(i)*crscabsi2(12,indexint)+
+     $        no2colx(i)*crscabsi2(13,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,11,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,11,i) = aux1(nlayermx-i+1) 
+      enddo
+
+
+c**************************************************
+c     h, 80.6-90.8nm
+c**************************************************
+
+      indexint=16
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $        o2colx(i)*crscabsi2(2,indexint)+
+     $        o3pcolx(i)*crscabsi2(3,indexint)+
+     $        n2colx(i)*crscabsi2(8,indexint)+
+     $        ncolx(i)*crscabsi2(9,indexint)+
+     $        nocolx(i)*crscabsi2(10,indexint)+
+     $        cocolx(i)*crscabsi2(11,indexint)+
+     $        hcolx(i)*crscabsi2(12,indexint)+
+     $        no2colx(i)*crscabsi2(13,indexint)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,12,nz2-i+1)
+         aux4(i) = c1_16(nz2-i+1,indexint)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,12,i) = aux1(nlayermx-i+1) 
+      enddo
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+
+c**************************************************
+c     n, 80.6-90.8nm
+c**************************************************
+
+         indexint=16
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,9,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,9,i) = aux1(nlayermx-i+1) 
+         enddo
+
+
+c**************************************************
+c     no, 80.6-90.8nm
+c**************************************************
+
+         indexint=16
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,10,i) = aux1(nlayermx-i+1) 
+         enddo
+
+
+c***********************************************************
+c     no2, 80.6-90.8nm
+c**************************************************
+
+         indexint=16
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+     $           o2colx(i)*crscabsi2(2,indexint)+
+     $           o3pcolx(i)*crscabsi2(3,indexint)+
+     $           n2colx(i)*crscabsi2(8,indexint)+
+     $           ncolx(i)*crscabsi2(9,indexint)+
+     $           nocolx(i)*crscabsi2(10,indexint)+
+     $           cocolx(i)*crscabsi2(11,indexint)+
+     $           hcolx(i)*crscabsi2(12,indexint)+
+     $           no2colx(i)*crscabsi2(13,indexint)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+            aux4(i) = c1_16(nz2-i+1,indexint)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,13,i) = aux1(nlayermx-i+1) 
+         enddo
+      
+         endif !Of chemthermod >= 2
+
+c**************************************************
+c      co2, 90.9-119.5nm
+c**************************************************
 
       limdown=1e-20
       limup=1e26
       do indexint=17,24
-         do i=1,nz
-            aux2(nz-i+1) = co2colx(i) + o2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,1,nz2-i+1)
-            aux4(i) = c12(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-c           print*,indexint,i,aux2(i),aux1(i),aux3(i),aux4(i)
-           jfotsout(indexint,1,i) = aux1(nz-i+1)
-           if(indexint.eq.24) then
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-             jfotsout(indexint,1,i) = aux1(nz-i+1)
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + n2colx(i) +
+     $           nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
+            aux4(i) = c17_24(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
+            if(indexint.eq.24) then
+          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+               jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
      $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))*
      $           (1+alfa(indexint,i)*(t2(i)-t0(i)))
-           else 
-             jfotsout(indexint,1,i)=0.
-           end if
-           end if
-c           print*,indexint,i,(jfotsout(indexint,j,i),j=1,nabs)
-         enddo
-      end do
-
-
-c************************************************
-c     o2,90.9,119.5
-c************************************************
+               else 
+                  jfotsout(indexint,1,i)=0.
+               end if
+            end if
+         enddo
+      end do
+
+
+c**************************************************
+c     o2, 90.9-119.5nm
+c**************************************************
       
       do indexint=17,24
-         do i=1,nz
-            aux2(nz-i+1) = o2colx(i) + co2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,2,nz2-i+1)
-            aux4(i) = c12(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-            jfotsout(indexint,2,i) = aux1(nz-i+1)
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
+     $           nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+            aux4(i) = c17_24(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
             if(indexint.eq.24) then
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,2,i) = aux1(nz-i+1)
+          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+               jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
      $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
                else
